<div class="umb-forms-designer clearfix">

    <umb-editor-sub-header style="margin-bottom: 0;">
        <umb-editor-sub-header-content-right>
            <umb-button
                type="button"
                button-style="outline"
                label-key="{{sortingButtonKey}}"
                icon="icon-navigation"
                action="toggleSortingMode();"
                size="xs">
            </umb-button>
        </umb-editor-sub-header-content-right>
    </umb-editor-sub-header>

    <div class="umb-forms__pages" ui-sortable="sortablePages" ng-model="form.pages">

        <div class="umb-forms__page sortable" ng-repeat="page in form.pages" data-umb="page_{{$index}}">

            <div class="umb-forms__page-header">

                <i class="icon-navigation umb-forms__page-sort-handle sortable-handle" ng-if="sortingMode"></i>

                <div class="umb-forms__page-number">{{ $index + 1 }}</div>

                <input type="text"
                   class="umb-forms__page-name"
                   ng-model="page.caption"
                   no-password-manager
                   placeholder="Untitled page (optional)">

                <div class="umb-forms__page-actions -page">
                    <a href="" title="Edit" ng-click="editPage(page)"><i class="icon-settings"></i></a>
                    <span ng-if="form.pages.length > 1">
                        <i class="icon-trash" title="Delete" ng-click="toggleDeletePrompt(page)"></i>
                        <umb-confirm-action ng-if="page.deletePrompt"
                                            direction="left"
                                            on-confirm="removePage(form.pages, $index)"
                                            on-cancel="hideDeletePrompt(page)">
                        </umb-confirm-action>
                    </span>
                </div>

            </div>

            <div class="umb-forms__page-condition" ng-if="page.buttonCondition.enabled">
                {{ page.buttonCondition.actionType }} buttons for this page if <strong>{{ page.buttonCondition.logicType | lowercase }}</strong> of the following match:
                <span ng-repeat="rule in page.buttonCondition.rules" data-umb="rule_{{$parent.$index}}_{{$index}}">
                    <span><strong>{{ getFieldNameFromGuid(rule.field) }}</strong> {{ rule.operator }} <strong>{{ rule.value }}</strong></span><span ng-if="!$last">, </span>
                </span>
            </div>

            <div class="umb-forms__fieldsets" ng-class="{'-empty': page.fieldSets.length === 0}" ui-sortable="sortableFieldsets" ng-model="page.fieldSets">

                <div class="umb-forms__fieldset sortable" ng-repeat="fieldset in page.fieldSets track by fieldset.id" ng-class="{'-active':fieldset.state =='active'}" ng-click="setActive(fieldset)"  data-umb="fieldset_{{$parent.$index}}_{{$index}}">

                    <div class="umb-forms__fieldset-header">

                        <div class="umb-forms__fieldset-info">
                            <i class="icon-navigation umb-forms__fieldset-sort-handle sortable-handle" ng-if="sortingMode"></i>
                            <input
                                class="umb-forms__fieldset-name"
                                ng-if="!sortingMode"
                                placeholder="Untitled group (optional)"
                                ng-model="fieldset.caption"
                                no-password-manager
                                umb-auto-resize />
                            <div class="umb-forms__fieldset-name" ng-if="sortingMode">{{ fieldset.caption }}</div>
                        </div>

                        <div class="umb-forms__page-actions -fieldset" ng-if="!sortingMode">
                            <a href="" title="Edit" ng-click="editFieldset(fieldset)"><i class="icon-settings"></i></a>
                            <span>
                                <i class="icon-documents" title="Copy" ng-click="toggleCopyPrompt(fieldset)"></i>
                                <umb-confirm-action ng-if="fieldset.copyPrompt"
                                                    direction="left"
                                                    on-confirm="copyFieldset(page, fieldset)"
                                                    on-cancel="hideCopyPrompt(fieldset)">
                                </umb-confirm-action>
                            </span>
                            <span>
                                <i class="icon-trash" title="Delete" ng-click="toggleDeletePrompt(fieldset)"></i>
                                <umb-confirm-action ng-if="fieldset.deletePrompt"
                                                    direction="left"
                                                    on-confirm="removeFieldset(page, fieldset)"
                                                    on-cancel="hideDeletePrompt(fieldset)">
                                </umb-confirm-action>
                            </span>
                        </div>

                    </div>

                    <div class="umb-forms__fieldset-condition" ng-if="fieldset.condition.enabled">
                        {{ fieldset.condition.actionType }} this group if <strong>{{ fieldset.condition.logicType | lowercase }}</strong> of the following match:
                        <span ng-repeat="rule in fieldset.condition.rules" data-umb="rule_{{$parent.$index}}_{{$index}}">
                            <span><strong>{{ getFieldNameFromGuid(rule.field) }}</strong> {{ rule.operator }} <strong>{{ rule.value }}</strong></span><span ng-if="!$last">, </span>
                        </span>
                    </div>

                    <div class="umb-forms__containers">

                        <div
                            class="umb-forms__container"
                            ng-class="{'-collapsed': sortingMode, '-element-column': fieldset.containers.length > 1 }"
                            ng-repeat="container in fieldset.containers" data-umb="container_{{$parent.$index}}_{{$index}}">

                            <div class="umb-forms__fields" ng-class="{'-empty': container.fields.length === 0}" ui-sortable="sortableFields" ng-model="container.fields" >

                                <div class="umb-forms__field sortable" ng-class="{'-collapsed': sortingMode}" ng-repeat="field in container.fields track by field.id" data-umb="field_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">

                                    <div class="umb-forms__field-content">

                                        <i class="icon-navigation umb-forms__field-sort-handle sortable-handle" ng-if="sortingMode"></i>

                                        <div class="umb-forms__field-info" ng-class="{'-inline': sortingMode}">

                                            <umb-locked-field
                                                ng-if="field.alias"
                                                locked="locked"
                                                ng-model="field.alias"
                                                placeholder-text="'Alias...'"
                                                server-validation-field="{{'field_' + field.alias}}" data-umb="field_alias_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">
                                            </umb-locked-field>

                                            <div class="umb-forms__field-mandatory" ng-if="field.mandatory">*</div>

                                            <textarea
                                                class="umb-forms__field-name"
                                                ng-if="!sortingMode"
                                                placeholder="Question"
                                                ng-model="field.caption"
                                                umb-auto-resize data-umb="field_name_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">
                                            </textarea>
                                            <div class="umb-forms__field-name" ng-if="sortingMode">{{ field.caption }}</div>

                                            <textarea
                                                placeholder="Help text"
                                                class="umb-forms__field-description"
                                                ng-model="field.tooltip"
                                                umb-auto-resize data-umb="help_text_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">
                                            </textarea>

                                        </div>

                                        <div class="umb-forms__field-wrapper">

                                            <div class="umb-group-builder__property-tag -white" ng-if="field.containsSensitiveData">
                                                <i class="icon-lock umb-group-builder__property-tag-icon"></i>
                                                <localize key="contentTypeEditor_isSensitiveData">Is sensitive data</localize>
                                            </div>

                                            <div class="umb-forms__field-condition" ng-if="field.condition.enabled">
                                                {{ field.condition.actionType }} this question if <strong>{{ field.condition.logicType | lowercase }}</strong> of the following match:
                                                <span ng-repeat="rule in field.condition.rules"  data-umb="rule_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">
                                                  <span><strong>{{ getFieldNameFromGuid(rule.field) }}</strong> {{ rule.operator }} <strong>{{ rule.value }}</strong></span><span ng-if="!$last">, </span>
                                                </span>
                                            </div>

                                            <div class="umb-forms__field-preview">
                                                <div ng-include="field.$fieldType.view"></div>
                                            </div>

                                        </div>

                                        <div class="umb-forms__actions" ng-if="sortingMode === false">
                                            <a href="" ng-click="openFieldSettings(field)" title="Edit"><i class="icon-settings" data-umb="open-field-settings_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}"></i></a>
                                            <span>
                                                <i class="icon-documents" title="Copy" ng-click="toggleCopyPrompt(field)" data-umb="copy_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}"></i>
                                                <umb-confirm-action ng-if="field.copyPrompt"
                                                                    direction="left"
                                                                    on-confirm="copyField(container, field)"
                                                                    on-cancel="hideCopyPrompt(field)" data-umb="copy_confirm_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">
                                                </umb-confirm-action>
                                            </span>
                                            <span>
                                                <i class="icon-trash" title="Delete" ng-click="toggleDeletePrompt(field)" data-umb="delete_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}"></i>
                                                <umb-confirm-action ng-if="field.deletePrompt"
                                                                    direction="left"
                                                                    on-confirm="removeField(fieldset, container, field)"
                                                                    on-cancel="hideDeletePrompt(field)" data-umb="delete_confirm_{{$parent.$parent.$index}}_{{$parent.$index}}_{{$index}}">
                                                </umb-confirm-action>
                                            </span>
                                        </div>

                                    </div>

                                </div>

                                <div class="umb-forms__no-fields" ng-if="container.fields.length === 0 && !sortingMode">
                                    <umb-button
                                        button-style="info"
                                        type="button"
                                        action="addField(fieldset, container)"
                                        label="Add question" data-umb="forms-add-question">
                                    </umb-button>
                                </div>

                                <div class="umb-forms__field-footer" ng-if="container.fields.length > 0 && !sortingMode">
                                    <umb-button
                                        button-style="info"
                                        type="button"
                                        action="addField(fieldset, container)"
                                        label="Add question">
                                    </umb-button>
                                </div>

                                <div class="umb-forms__no-fields" ng-if="container.fields.length === 0 && sortingMode">
                                    <div ng-if="!container.dropOnEmpty">
                                        <p class="umb-forms__no-fields-text" >Group is empty</p>
                                        <small>Drop a question here...</small>
                                    </div>
                                    <div ng-if="container.dropOnEmpty">
                                        <p class="umb-forms__no-fields-text">Yaay.. let go</p>
                                    </div>
                                </div>

                            </div>

                        </div>
                    </div>
                </div>

                <div class="umb-forms__no-fields" ng-if="page.fieldSets.length === 0 && sortingMode">
                    <div ng-if="!page.dropOnEmpty">
                        <p class="umb-forms__no-fields-text">Page is empty</p>
                        <small>Drop a group here...</small>
                    </div>
                    <div ng-if="page.dropOnEmpty">
                        <p class="umb-forms__no-fields-text">Yaay.. let go</p>
                    </div>
                </div>

                <!-- Add new sections if fields are present -->
                <div class="umb-forms__page-footer" ng-if="!sortingMode && pageHasFields(page)">
                    <umb-button
                        button-style="link"
                        type="button"
                        action="addFieldset(page)"
                        label="Add new group">
                    </umb-button>
                </div>

            </div>

        </div>

    </div>

    <div class="umb-forms__footer">
        <umb-button
            ng-if="!sortingMode && formHasFields(form)"
            type="button"
            action="addPage(form)"
            label="Add new page">
        </umb-button>
    </div>

    <div class="umb-forms-workflow-actions" ng-if="!sortingMode">

        <div class="umb-forms-workflow-flows">

            <div class="umb-forms-workflow-flow">

                <span class="umb-forms-workflow-preview">
                    <span class="umb-forms__page-number"><i class="icon-check"></i></span>
                    On
                </span>

                <span class="umb-forms-workflow-preview">
                    <strong>&nbsp; {{ form.submitLabel }} &rarr;</strong>
                </span>

                <span class="umb-forms-workflow-preview">
                    <a class="umb-forms-workflow-preview__item" href="" ng-click="editSubmitMessageWorkflow()">Submit message / Go to page</a>
                    <span ng-if="(form.formWorkflows.onSubmit | filter:{isDeleted:'false'}).length > 0">and</span>
                </span>

                <span class="umb-forms-workflow-preview" ng-repeat="workflow in form.formWorkflows.onSubmit | filter:{isDeleted:'false'}" data-umb="on_submit_workflow_{{$index}}">
                    <a class="umb-forms-workflow-preview__item" ng-class="{'umb-forms-workflow-preview__item--inactive': !workflow.active}" ng-if="security.userSecurity.manageWorkflows" href="" ng-click="editWorkflowSettings(workflow, 'onSubmit', $index)" data-umb="{{ workflow.name }}">{{ workflow.name }}</a>
                    <span class="umb-forms-workflow-preview__item" ng-if="security.userSecurity.manageWorkflows === false">{{ workflow.name }}</span>
                    <span ng-if="!$last">and</span>
                </span>
            </div>

            <div class="umb-forms-workflow-flow" ng-if="form.manualApproval || (form.formWorkflows.onApprove | filter:{isDeleted:'false'}).length > 0">
                <span class="umb-forms-workflow-preview">
                    <span class="umb-forms__page-number"><i class="icon-thumb-up"></i></span>
                    On
                </span>

                <span class="umb-forms-workflow-preview">
                    <strong>&nbsp; Approve <span ng-show="!form.manualApproval">(automatic)</span> &rarr;</strong>
                </span>

                <span class="umb-forms-workflow-preview" ng-repeat="workflow in form.formWorkflows.onApprove | filter:{isDeleted:'false'}" data-umb="onapprove_workflow_{{$index}}">
                    <a class="umb-forms-workflow-preview__item" ng-class="{'umb-forms-workflow-preview__item--inactive': !workflow.active}" ng-if="security.userSecurity.manageWorkflows" href="" ng-click="editWorkflowSettings(workflow, 'onApprove', $index)">{{ workflow.name }}</a>
                    <span class="umb-forms-workflow-preview__item" ng-if="security.userSecurity.manageWorkflows === false">{{ workflow.name }}</span>
                    <span ng-if="!$last">and</span>
                </span>

                <span class="umb-forms-workflow-preview" ng-if="(form.formWorkflows.onApprove | filter:{isDeleted:'false'} ).length === 0">&nbsp; No workflows are added</span>

            </div>

        </div>

        <div class="umb-forms-workflow-settings" ng-if="security.userSecurity.manageWorkflows">
            <a href="" ng-click="editWorkflows()">configure workflow</a>
        </div>

    </div>

    <umb-overlay
        ng-if="fieldOverlay.show"
        model="fieldOverlay"
        position="target"
        view="fieldOverlay.view">
    </umb-overlay>

    <umb-overlay
        ng-if="workflowSettingsOverlay.show"
        model="workflowSettingsOverlay"
        position="right"
        view="workflowSettingsOverlay.view">
    </umb-overlay>
    
    <umb-overlay
        ng-if="fieldsetSettingsOverlay.show"
        model="fieldsetSettingsOverlay"
        position="right"
        view="fieldsetSettingsOverlay.view">
    </umb-overlay>

</div>
